<?php
	include "utils.php";
	include "config.php";
	set_time_limit(0);

	function genUsage($filename,$mode) // generate possible abuse usage report
	{
		include "country_code.php";
        include "isp_code.php";
		$fpath = generateLogPath($filename);
		$total_input_size = 0; // total input traffic in bytes
		$total_output_size = 0; // total input traffic in bytes
		$date_range = array();
		$dns_cache = array();
		$users_ip_usage_count = array();
		$users_ip_list = array();
		$last_seen_onsite = array();
		$stime = microtime(true);
		$lines = file($fpath);
		$linecount = 0;
		if(isset($_SESSION['dns_cache']))
			$dns_cache_session = $_SESSION['dns_cache'];
		foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			$vald = substr($tokens[3],0,10);
			if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
				$start_date = $_REQUEST['dateselbox_s'];
			if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
				$end_date = $_REQUEST['dateselbox_e'];
			if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			{
				$current_username = $tokens[1]; // username
				$garray = explode(",",$tokens[2]);
				if(count($garray) > 1)
					$current_group = $garray[0];  // group
				else
					$current_group = $tokens[2];  // group
				if($tokens[4] == "w" || $tokens[4] == "r" || $tokens[4] == "l" || $tokens[4] == "e" || $tokens[4] == "m" || $tokens[4] == "d" || $tokens[4] == "s")
				{
						if(isset($users_ip_list[$current_username]) == false)
						{
							$users_ip_usage_count[$current_username] = 1;
							$users_ip_list[$current_username] = array(1 => $tokens[0]); // must start from 1 index -- warning
						}
						else
						{
							$tmparr  = $users_ip_list[$current_username];
							if(array_search($tokens[0],$tmparr) == false)
							{
								array_push($tmparr,$tokens[0]);
								$users_ip_usage_count[$current_username] = count($tmparr);
								$users_ip_list[$current_username] = $tmparr;
							}
						}
				}
			}
		}
		$etime = microtime(true);
		$str_lines               = $linecount;
        $str_time_taken          = round(($etime - $stime),3) . " s";
		$str_size_logfile        = byte_format(filesize($fpath));
        
        // New info
        echo '<div class="info">';
        echo '<table id="gridInfo" class="gridInfo" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="400">Information</td><td width="100">Value</td></tr></thead><tbody>';
        echo "<tr><td>Total number of lines in LOG file</td><td>$linecount</td></tr>\n";
        echo "<tr><td>Time taken for analysis</td><td>$str_time_taken</td></tr>\n";
        echo "<tr><td>LOG file size</td><td>$str_size_logfile</td></tr>\n";
        echo '</tbody></table>';   
        echo '</div>';
          
		echo "<H3>Users and IP addresses</H3>";
		
        $counter = 0;
		arsort($users_ip_usage_count);
        echo '<div class="gridcontainer">';
        echo '<table id="grid1" class="grid" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="50"><div class="mycenter">No.</div></td><td width="120">Username</td><td width="120">IP addr.</td><td>Host name</td><td>Country</td></tr></thead><tbody>';
		foreach($users_ip_usage_count as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
			if($val <= 1)
				$ipk = "IP";
			else
				$ipk = "IPs";
			echo "<tr><td>$itag</td><td><div class='path'>$key" . "@" . $val . " $ipk</div></td><td> </td><td> </td><td> </td></tr>";
			asort($users_ip_list[$key]);
			foreach($users_ip_list[$key] as $key2 => $val2)
			{
				if(isPrivateIP($val2) == false)
				{
					if(isset($dns_cache_session))
					{
						$test = isset($dns_cache_session[$val2]);
                        if(isset($dns_cache_session[$val2]) == true)
                        {  $r_hostname = $dns_cache_session[$val2]; }
                        else
						{ $r_hostname = gethostbyaddr($val2); 
                        }
					}
					else
                    { $r_hostname = gethostbyaddr($val2); 
                    }
				}
				else
                {  $r_hostname = "Intranet"; }
                $dns_cache[$val2] = $r_hostname;
				$dmarr = explode(".",$r_hostname);
				$dma = " ";
				if(count($dmarr) > 1)
				{
					$lastcnt = count($dmarr) - 1;
					$lastdm = $dmarr[$lastcnt];
					if(isset($countrycode[$lastdm]) == true)
						{ $dma = $countrycode[$lastdm]; }
                    else if(count($dmarr) > 2) {
                        $beforelastcnt = count($dmarr) - 2;
                        $beforelastdm = $dmarr[$beforelastcnt] . "." . $dmarr[$beforelastcnt + 1];
                        if(isset($ispcode[$beforelastdm]) == true)
                        { $dma = $ispcode[$beforelastdm]; }
                    }
                }
				echo "<tr><td>&nbsp;</td><td><div class='path'>&nbsp;</div></td><td>$val2</td><td>$r_hostname</td><td>$dma</td></tr>";
			}
		}
		echo '</tbody></table>';
        echo '</div>';

		if(isset($_SESSION['dns_cache']) == false)
			$_SESSION['dns_cache'] = $dns_cache;
		else
			$_SESSION['dns_cache'] = array_merge($_SESSION['dns_cache'],$dns_cache);
            
        echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
	}

	function generateLogPath($filename)
	{
		global $rdnpath;
		if(isFilenameSecure($filename) == false)
			die("Invalid filename");
		$ext = getFileType($filename);
		if($ext != "log")
			die("Not a Log file");
		$fpath = $rdnpath . "\\log\\" . $filename;
		if(file_exists($fpath) == true)
			return $fpath;
		else
			die("invalid log file path");
	}

	function getCommand($cmdstring)
    {
        $command = "";
        
        if($cmdstring == "l")     { $command = "Login"; }
        elseif($cmdstring == "m") { $command = "Create"; }
        elseif($cmdstring == "w") { $command = "Upload"; }
        elseif($cmdstring == "r") { $command = "Download"; }
        elseif($cmdstring == "s") { $command = "SiteCmd"; }
        elseif($cmdstring == "d") { $command = "Delete"; }
        elseif($cmdstring == "e") { $command = "Error"; }
        elseif(substr($cmdstring,0,6) == "ask://")   { $command = "Ask"; }
        elseif(substr($cmdstring,0,7) == "exec://")  { $command = "Exec"; }
        elseif(substr($cmdstring,0,7) == "file://")  { $command = "File"; }
        elseif(substr($cmdstring,0,7) == "http://")  { $command = "Http"; }
        elseif(substr($cmdstring,0,6) == "log://")   { $command = "Log"; }
        elseif(substr($cmdstring,0,6) == "queue://") { $command = "Queue"; }
    
        return $command;
    }
        
    function genFilteredLogList($filename)
    {
        global $maxresults;
        global $subfolderignore; 
        $users = array();
        $groups = array();
        $actions = array();
        
        if(isset($_REQUEST['op']) == true && $_REQUEST['op'] != ""){
            $op = $_REQUEST['op']; }
        else { $op = ""; }
        if(isset($_REQUEST['users']) == true && $_REQUEST['users'] != ""){
            $users = explode ("|",$_REQUEST['users']); }
        else { $users[0] = '#ALL#'; } 
        if(isset($_REQUEST['groups']) == true && $_REQUEST['groups'] != "") {
            $groups = explode ("|",$_REQUEST['groups']); }
        else { $groups[0] = '#ALL#'; }
        if(isset($_REQUEST['actions']) == true && $_REQUEST['actions'] != "") {
            $actions = explode ("|",$_REQUEST['actions']); }
        else { $actions = array(); }
        if(isset($_REQUEST['groupfolder']) == true && $_REQUEST['groupfolder'] != "") {
            $groupfolder = $_REQUEST['groupfolder']; }
        else { $groupfolder = 'true'; }
        if(isset($_REQUEST['foldertimestamp']) == true && $_REQUEST['foldertimestamp'] != "") {
            $foldertimestamp = $_REQUEST['foldertimestamp']; }
        else { $foldertimestamp = 'last'; }
        if(isset($_REQUEST['orderacend']) == true && $_REQUEST['orderacend'] != "") {
            $orderacend = $_REQUEST['orderacend']; }
        else { $orderacend = 'false'; }
        if(isset($_REQUEST['orderby']) == true && $_REQUEST['orderby'] != "") {
            $orderby = $_REQUEST['orderby']; }
        else { $orderby = '0'; }
        
        $fpath = generateLogPath($filename);
        $date_range = array();
        $filteredArray = array();
        $groupingArray = array();
        $stime = microtime(true);
        $lines = file($fpath);
        $linecount = 0;
        $ecount = 0;
        $cnt = 0;
        
        // Read the data
        //----------------------------------
        foreach($lines as $line_num => $line)
        {
            $linecount++;
            $line = trim($line);
            $tokens = csv_explode(" ",$line);
                $vald = substr($tokens[3],0,10);
                if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
                    $start_date = $_REQUEST['dateselbox_s'];
                if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
                    $end_date = $_REQUEST['dateselbox_e'];
                if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
                {
                    if ((in_array($tokens[1],$users)) || ($users[0] == "#ALL#"))
                    {
                        $matchedgroup = false;
                        foreach (explode(",",$tokens[2]) as $group) {
                           if ((in_array($group,$groups)) || ($groups[0] == "#ALL#")){
                               $matchedgroup = true;
                               break; }}
                        if ($matchedgroup == true) {
                            $command = getCommand($tokens[4]);
                            if ((in_array(strtolower($command),$actions)) || (count($actions) == 0)) {
                                if ($groupfolder == "false") {
                                     $filteredArray[$ecount] = $line;
                                     $ecount++; 
                                }
                                elseif (($tokens[4] == 'r') || ($tokens[4] == 'w'))
                                {
                                   $groupkey =  $tokens[1] . "-" .  basepath($tokens[5],$subfolderignore);
                                   $exists = array_key_exists($groupkey,$groupingArray);
                                   if ($exists == true) {                       
                                           if (($groupingArray[$groupkey][4] == $tokens[4]) && (samepaths($groupingArray[$groupkey][5],$tokens[5],$subfolderignore))) {
                                               //Calc avg
                                               if (($groupingArray[$groupkey][6] + $tokens[6]) != 0)
                                               {
                                                   $groupingArray[$groupkey][7] = (($groupingArray[$groupkey][7] * $groupingArray[$groupkey][6]) + ($tokens[7] * $tokens[6]))/($groupingArray[$groupkey][6] + $tokens[6]);
                                               }
                                               
                                               //Update size
                                               $groupingArray[$groupkey][6] = $groupingArray[$groupkey][6] + $tokens[6];
                                               //update count
                                               $groupingArray[$groupkey][9] = $groupingArray[$groupkey][9] + 1; 
                                               //update Filenames
                                               $groupingArray[$groupkey][10] = $groupingArray[$groupkey][10] . "\n" . basename($tokens[5]);
                                               //update Timestamp
                                               $groupingArray[$groupkey][8] = $tokens[3];
                                           }
                                   }                  
                                   else {
                                        //first
                                        $tokens[8] = $tokens[3];
                                        $tokens[9] = 1;
                                        $tokens[10] = basename($tokens[5]);
                                        $groupingArray[$groupkey] = $tokens;
                                   } 
                                }
                            }
                        }
                    }
                }    
        }
            
        //if "last file" date is used, the list is not ordered !!
        //-----------------------------------------------------
         if (strtolower($foldertimestamp) == "last")
         { 
           $arrtimestamp = array_map('col_8', $groupingArray);  
         }
         else {
              $arrtimestamp = array_map('col_3', $groupingArray);
         }
        $arrcount = array_map('col_9', $groupingArray);
        $arrsize = array_map('col_6', $groupingArray);

        

        // set the ordering array
        if (strtolower($orderby) == 'count') { $arr1 = $arrcount; }
        else if (strtolower($orderby) == 'size') { $arr1 = $arrsize; }
        else { $arr1 = $arrtimestamp; }

        // set the sort order
        if (strtolower($orderacend) == 'true') { 
            array_multisort($arr1, SORT_ASC, $groupingArray); }
        else { 
            array_multisort($arr1, SORT_DESC, $groupingArray); }
        
        
 //       if (strtolower($foldertimestamp) == "last") { 
//            $tmpArray = array();
//            foreach ($groupingArray as $key => $val) 
//                {
                    //use Timestamp as key
//                    $tmpArray[$val[8]] = $val;
//                }
//            $groupingArray = $tmpArray; 
//            if (strtolower($orderacend) == 'true') { ksort($groupingArray); }
//                else { krsort($groupingArray); } 
//        }
         
        $etime = microtime(true);
        $str_lines               = $linecount;
        $str_time_taken          = round(($etime - $stime),3) . " s";
        $str_size_logfile        = byte_format(filesize($fpath));
        
        
        // Output info if op 15 or 17
        //-----------------------------------------------------
          if (($op=="showfoldersdl") || ($op == "showfoldersul")) {
                echo '<div class="info">';
                echo '<table id="gridInfo" class="gridInfo" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=300>Information</td><td width=100>Value</td></tr></thead><tbody>';
                echo "<tr><td>Total number of lines in LOG file</td><td>$linecount</td></tr>\n";
                echo "<tr><td>Time taken for analysis</td><td>$str_time_taken</td></tr>\n";
                echo "<tr><td>LOG file size</td><td>$str_size_logfile</td></tr>\n";
                echo "<tr><td>Max Results</td><td>$maxresults</td></tr>\n";
                echo '</tbody></table>';   
                echo '</div>';    
          }
 
        // Now we process
        //-----------------------------------------------------
        $counter = 0;
        
          if ($groupfolder == "false") {
             $totalecount = count($filteredArray);    
             if ($totalecount > $maxresults) {$showed = $maxresults; } 
             else {$showed = $totalecount; }   
             echo "<h3>Filtered list - " . $showed . " of " .  $totalecount . " entries</h3>";
             echo '<div class="gridcontainer">';
             echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td align:center>IP</div></td><td>User</td><td>Timestamp</td><td>Action</td><td>Param 1</td><td>Param 2</td><td>Param 3</td></tr></thead><tbody>';
                for($i=0;$i<=$totalecount - 1 ;$i++)
                {
                    $counter++;
                    if (strtolower($orderacend) == 'true') { $thiscount = $i; }
                    else { $thiscount = $totalecount - $i - 1; }
                    
                    $tokens = csv_explode(" ",$filteredArray[$thiscount]);

                    $command = getCommand($tokens[4]);
                    if ((strtolower($command) == "login") || (strtolower($command) == "create") || (strtolower($command) == "delete") || (strtolower($command) == "error") || (strtolower($command) == "sitecmd")) {
                        echo "<tr><td>$tokens[0]</td><td title='$tokens[2]'>$tokens[1]</td><td>$tokens[3]</td><td>$command</td><td>$tokens[5]</td><td></td><td></td></tr>\n"; }
                    elseif ((strtolower($command) == "upload") || (strtolower($command) == "download")) {
                        echo "<tr align:center><td>$tokens[0]</td><td title='$tokens[2]'>$tokens[1]</td><td>$tokens[3]</td><td>$command</td><td>$tokens[5]</td><td white-space: nowrap>" . byte_format($tokens[6]) . "</td><td white-space: nowrap>$tokens[7] Kb/s</td></tr>\n"; }
                    elseif ((strtolower($command) == "ask") || (strtolower($command) == "exec") || (strtolower($command) == "file") || (strtolower($command) == "log") || (strtolower($command) == "http") || (strtolower($command) == "queue")) {
                        $cmdstr = substr($tokens[4],strlen($command)+3);
                        $cmdparams = "";
                        $pos = strposOffset(" ",$filteredArray[$thiscount],4); 
                        $cmdparams = substr($filteredArray[$thiscount],$pos);
                        echo "<tr><td>$tokens[0]</td><td title='$tokens[2]'>$tokens[1]</td><td>$tokens[3]</td><td>$command</td><td>$cmdstr</td><td>$cmdparams</td><td></td></tr>\n"; }
                          
                    if($i >= intval($maxresults))
                        break;
                }
                echo '</tbody></table>';
                echo '</div>';
                echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
          }
          else {
             $totalecount = count($groupingArray);
             if ($totalecount > $maxresults) {$showed = $maxresults; } 
             else {$showed = $totalecount; }   
             echo "<h3>Folders - " . $showed . " of " .  $totalecount . " entries</h3>";
             echo '<div class="gridcontainer">';
             echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td>User</td><td>Timestamp</td><td>Action</td><td>Folder</td><td align=center>Files</td><td align=center>Size</td><td>Avg.Speed</td></tr></thead><tbody>';
            
                
                foreach ($groupingArray as $key => $val) 
                {
                    $counter++;
                    
                    $thiscount = $totalecount - $counter;
                    $tokens = $val;
                    $command = getCommand($tokens[4]);
                    if ((strtolower($command) == "upload") || (strtolower($command) == "download")) {
                        if (strlen($tokens[10]) >= 512) {
                            $tmpstr = substr($tokens[10],0,508);
                            $lastpos = strrpos($tmpstr,"\n", -0);
                            if ($lastpos > 0) { $files = substr($tmpstr,0,$lastpos) . "\n..."; }
                        }    
                        else { $files = $tokens[10]; }
                        
                         if (strtolower($foldertimestamp) == "last") { $ts = $tokens[8]; }
                         else {$ts = $tokens[3];}
                        
                        echo "<td title='$tokens[2]'>$tokens[1]</td><td Title='Start: $tokens[3]\nEnd: $tokens[8]'>$ts</td><td>$command</td><td title='$files'>" . basepath($tokens[5],$subfolderignore) . '</td><td align=center white-space: nowrap>' . $tokens[9] .'</td><td align=center white-space: nowrap>' . byte_format($tokens[6]) . '</td><td white-space: nowrap>' . intval($tokens[7]) . " Kb/s</td></tr>\n"; }
               
                        if($counter >= intval($maxresults)) { break; }
                }
                echo '</tbody></table>';
                echo '</div>';
                echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
          }
    }
    
    function genLogList($filename,$mode)
	{
		global $maxresults;
        $keyword = "e";
		if($mode == 6)
			$keyword = "e";
		else if($mode == 7)
			$keyword = "d";
		else if($mode == 8)
			$keyword = "s";
		else if($mode == 9)
			$keyword = "l";
		else if($mode == 10)
			$keyword = "m";
		else if($mode == 11)
			$keyword = "w";
		else if($mode == 12)
			$keyword = "r";
        else if($mode == 14)
            $keyword = "ask";
        else
            die("<div class='info'>Unknown Mode requested.</div>");
            
		$fpath = generateLogPath($filename);
		$date_range = array();
		$errorsArray = array();
		$stime = microtime(true);
		$lines = file($fpath);
		$linecount = 0;
		$ecount = 0;
		foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			    $vald = substr($tokens[3],0,10);
			    if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
				    $start_date = $_REQUEST['dateselbox_s'];
			    if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
				    $end_date = $_REQUEST['dateselbox_e'];
			    if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			    {
				    if ($mode == 14)
                    {
                        if((substr($tokens[4],0,4) == "ask:") || (substr($tokens[4],0,5) == "exec:") || (substr($tokens[4],0,5) == "file:") || (substr($tokens[4],0,5) == "http:") || (substr($tokens[4],0,4) == "log:") || (substr($tokens[4],0,6) == "queue:")) // extract log entries
                        {
                            $errorsArray[$ecount] = $line;
                            $ecount++;
                        }        
                    }
                    elseif($tokens[4] == $keyword) // extract log entries
				    {
					    $errorsArray[$ecount] = $line;
						$ecount++;
				    }
			    }
		}
		$etime = microtime(true);
		
		$str_lines               = $linecount;
		$str_time_taken          = round(($etime - $stime),3) . " s";
		$str_size_logfile        = byte_format(filesize($fpath));
		
        // New info
        echo '<div class="info">';
        echo '<table id="gridInfo" class="gridInfo" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=300>Information</td><td width=100>Value</td></tr></thead><tbody>';
        echo "<tr><td>Total number of lines in LOG file</td><td>$linecount</td></tr>\n";
        echo "<tr><td>Time taken for analysis</td><td>$str_time_taken</td></tr>\n";
        echo "<tr><td>LOG file size</td><td>$str_size_logfile</td></tr>\n";
        echo "<tr><td>Max Results</td><td>$maxresults</td></tr>\n";
        echo '</tbody></table>';   
        echo '</div>';
		
        $counter = 0;
		$totalecount = count($errorsArray);
        
        if ($totalecount > $maxresults) {$showed = $maxresults; } 
        else {$showed = $totalecount; }   
        
		if($mode == 7 || $mode == 10)
		{
			if ($mode == 7)
            {
                echo "<h3>Deleted Items - " . $showed . " of " .  $totalecount . " entries</h3>";
            }
            else if($mode == 10)
            {
                echo "<h3>Folder Creates - " . $showed . " of " .  $totalecount . " entries</h3>";
            }
            echo '<div class="gridcontainer">';
            echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50><div class="mycenter">No.</div></td><td width=120>IP addr.</td><td>Username</td><td>Timestamp</td><td>Path</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td><div class='rank'>$counter</div></td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td>$tokens[3]</td><td>$tokens[5]</td></tr>\n";
				if($i >= intval($maxresults))
					break;
			}
			echo '</tbody></table>';
            echo '</div>';
            
		}
		else if($mode == 9)
		{
            echo "<h3>Logins - " . $showed . " of " .  $totalecount . " entries</h3>";
			echo '<div class="gridcontainer">';
            echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50><div class="mycenter">No.</div></td><td width=120>IP addr.</td><td>Username</td><td>Timestamp</td><td>Information</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td><div class='rank'>$counter</div></td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td>$tokens[3]</td><td>$tokens[5]</td></tr>\n";
				if($i >= intval($maxresults))
					break;
			}
			echo '</tbody></table>';
            echo '</div>';
            
		}
		else if($mode == 8)
		{
			echo "<h3>Site Commands - " . $showed . " of " .  $totalecount . " entries</h3>";
            echo '<div class="gridcontainer">';
            echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50><div class="mycenter">No.</div></td><td width=120>IP addr.</td><td>Username</td><td>Timestamp</td><td>Command line</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td><div class='rank'>$counter</div></td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td>$tokens[3]</td><td title='cmd: " . $tokens[5] . "'>$tokens[5]</td></tr>\n";
				if($i >= intval($maxresults))
					break;
			}
			echo '</tbody></table>';
            echo '</div>';
            
		}
		else if($mode == 6)
		{
			echo "<h3>FTP Errors - " . $showed . " of " .  $totalecount . " entries</h3>";
            echo '<div class="gridcontainer">';
            echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50><div class="mycenter">No.</div></td><td width=120>IP addr.</td><td>Username</td><td>Timestamp</td><td>Error</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td><div class='rank'>$counter</div></td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td>$tokens[3]</td><td>$tokens[5]</td></tr>\n";
				if($i >= intval($maxresults))
					break;
			}
			echo '</tbody></table>';
            echo '</div>';
            
		}
        else if($mode == 14)
        {
            echo "<h3>FTP Ask & Exec - " . $showed . " of " .  $totalecount . " entries</h3>";
            
            echo '<div class="gridcontainer">';
            echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50><div class="mycenter">No.</div></td><td width=120>IP addr.</td><td>Username</td><td>Timestamp</td><td><div class="mycenter">Command</div></td><td>Command Parameters</td></tr></thead><tbody>';
            for($i=1;$i<=$totalecount;$i++)
            {
                $counter++;
                $thiscount = $totalecount - $i;
                $tokens = csv_explode(" ",$errorsArray[$thiscount]);
                if(substr($tokens[4],0,6) == "ask://")
                {
                    $command =  "Ask";
                }
                elseif(substr($tokens[4],0,7) == "exec://")
                {
                    $command =  "Exec";    
                }
                elseif(substr($tokens[4],0,7) == "file://")
                {
                    $command =  "File";    
                }
                elseif(substr($tokens[4],0,7) == "http://")
                {
                    $command =  "Http";    
                }
                if(substr($tokens[4],0,6) == "log://")
                {
                    $command =  "Log";
                }
                elseif(substr($tokens[4],0,8) == "queue://")
                {
                    $command =  "Queue";    
                }
                $cmdstring = "";
                for($cnt=4;$cnt<sizeof($tokens);$cnt++)
                    {
                       $cmdstring = $cmdstring . " "  .  $tokens[$cnt];
                    } 
                echo "<tr><td><div class='rank'>$counter</div></td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td>$tokens[3]</td><td><div class='mycenter'>$command</div></td><td title='Parameters: " . $cmdstring . "'>$cmdstring</td></tr>\n";
                if($i >= intval($maxresults))
                    break;
            }
            echo '</tbody></table>';
            echo '</div>';
            
        }
		else if (($mode == 11) || ($mode == 12))
		{
			if ($mode == 11)
            {
                echo "<h3>New Files - " . $showed . " of " .  $totalecount . " entries</h3>";
            }
            else if($mode == 12)
            {
                echo "<h3>File Downloads - " . $showed . " of " .  $totalecount . " entries</h3>";
            }
            echo '<div class="gridcontainer">';
            echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50><div class="mycenter">No.</div></td><td width=120>IP addr.</td><td>Username</td><td>Timestamp</td><td>Path</td><td white-space: nowrap>Size</td><td>Speed</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td><div class='rank'>$counter</div></td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td>$tokens[3]</td><td>$tokens[5]</td><td white-space: nowrap>" . byte_format($tokens[6]) . "</td><td white-space: nowrap>$tokens[7] Kb/s</td></tr>\n";
				if($i >= intval($maxresults))
					break;
			}
			echo '</tbody></table>';
            echo '</div>';
            
        }
        else {}
        echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
	}

	function genTrafficGraph($filename)
	{
		$fpath = generateLogPath($filename);
		$total_input_size = 0; // total input traffic in bytes
		$total_output_size = 0; // total input traffic in bytes
		$average_input_speed = 0; // average output speed in kb/s
		$average_output_speed = 0; // average output speed in kb/s
		$num_of_logins = 0; // login attempt count
		$num_of_ips    = 0; // login ip count
		$tmp_w_counter = 0;
		$tmp_w_spd_sum = 0;
		$tmp_r_counter = 0;
		$tmp_r_spd_sum = 0;
		$ip_range = array();
		$date_range = array();
		$datehour_traffic_o = array(); // output date and hour traffic data
		$datehour_traffic_i = array(); // input date and hour traffic data
		$datehour_spd_o = array(); // output date and hour speed data
		$datehour_spd_i = array(); // input date and hour speed data
		$stime = microtime(true);
		$lines = file($fpath);
		$linecount = 0;
		foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
            if(count($tokens) >= 6)
            {
			    if($tokens[4] == "w") // input traffic
			    {
				    if(count($tokens) >= 6)
				    {
					    if(is_numeric($tokens[6])) // output size in bytes
					    {
						    $total_input_size = $total_input_size + $tokens[6];
						    //echo "Line #<b>{$line_num}</b> : " . htmlspecialchars($line) . ">" . $tokens[7] . "<br>\n";
					    }
					    if(is_numeric($tokens[7])) // check speed field
					    {
						    $tmp_w_spd_sum = $tmp_w_spd_sum + $tokens[7];
						    $tmp_w_counter++;
					    }
					    $date1 = substr($tokens[3],0,10);
					    $hour1 = substr($tokens[3],11,2);
					    // generate traffic 24 hr data
					    if(isset($datehour_traffic_i[$date1][$hour1]))
						    $datehour_traffic_i[$date1][$hour1] = $datehour_traffic_i[$date1][$hour1] + $tokens[6];
					    else
						    $datehour_traffic_i[$date1][$hour1] = $tokens[6];
					    // generate avg speed 24 hr data
					    if(isset($datehour_spd_i[$date1][$hour1]))
						    $datehour_spd_i[$date1][$hour1] = ($datehour_spd_i[$date1][$hour1] + $tokens[7]) / 2;
					    else
						    $datehour_spd_i[$date1][$hour1] = $tokens[7];
					    if(isset($date_range[$date1]) == false) // there is traffic in this day
						    $date_range[$date1] = $date1;
				    }
			    }
			    else if($tokens[4] == "r") // input traffic
			    {
				    if(count($tokens) == 8)
				    {
					    if(is_numeric($tokens[6])) // output size in bytes
					    {
						    $total_output_size = $total_output_size + $tokens[6];
						    //echo "Line #<b>{$line_num}</b> : " . htmlspecialchars($line) . ">" . $tokens[7] . "<br>\n";
					    }
					    if(is_numeric($tokens[7])) // check speed field
					    {
						    $tmp_r_spd_sum = $tmp_r_spd_sum + $tokens[7];
						    $tmp_r_counter++;
					    }
					    $date1 = substr($tokens[3],0,10);
					    $hour1 = substr($tokens[3],11,2);
					    if(isset($datehour_traffic_o[$date1][$hour1]))
						    $datehour_traffic_o[$date1][$hour1] = $datehour_traffic_o[$date1][$hour1] + $tokens[6];
					    else
						    $datehour_traffic_o[$date1][$hour1] = $tokens[6];
					    if(isset($datehour_spd_o[$date1][$hour1]))
						    $datehour_spd_o[$date1][$hour1] = ($datehour_spd_o[$date1][$hour1] + $tokens[7]) / 2;
					    else
						    $datehour_spd_o[$date1][$hour1] = $tokens[7];
					    if(isset($date_range[$date1]) == false) // there is traffic in this day
						    $date_range[$date1] = $date1;
				    }
			    }
			    else if($tokens[4] == "l") // login attempt
			    {
				    $num_of_logins++;
			    }
			}
            $ips = $tokens[0];
			if(isset($ip_range[$ips]) == false)
				$ip_range[$ips] = 1;
			else
				$ip_range[$ips] = $ip_range[$ips] + 1;
		}
		$etime = microtime(true);
		$str_lines               = $linecount;
		$str_time_taken          = round(($etime - $stime),3) . " s";
		$str_size_logfile        =  byte_format(filesize($fpath),2);
		$str_total_upload_size   =  byte_format($total_input_size,2);
        if ($tmp_w_counter > 0)
		    $str_avg_upload_spd      = sprintf("%.2f",$tmp_w_spd_sum/$tmp_w_counter) . " Kb/s";
        else 
            $str_avg_upload_spd      = sprintf("%.2f",0) . " Kb/s";
        $str_total_download_size =  byte_format($total_output_size,2);
        if ($tmp_r_counter > 0)
            $str_avg_download_spd    = sprintf("%.2f",$tmp_r_spd_sum/$tmp_r_counter) . " Kb/s";
		else
            $str_avg_download_spd      = sprintf("%.2f",0) . " Kb/s";
        $str_num_logins          = $num_of_logins;
		$str_num_ip_origins      = count($ip_range);
		$str_most_active_ip      = "";
		arsort($ip_range);
		foreach($ip_range as $key => $val)
		{
			$str_most_active_ip  =  $key;
			break;
		}
		
        echo "<div class='info'>";
        // New info
        echo '<table id="gridInfo" class="gridInfo" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=400>Information</td><td width=100>Value</td></tr></thead><tbody>';
        echo "<tr><td>Total number of lines in LOG file</td><td>$linecount</td></tr>\n";
        echo "<tr><td>Time taken for analysis</td><td>$str_time_taken</td></tr>\n";
        echo "<tr><td>LOG file size</td><td>$str_size_logfile</td></tr>\n";
        echo "<tr><td>Total upload size</td><td>$str_total_upload_size </td></tr>\n";
        echo "<tr><td>Average upload speed</td><td>$str_avg_upload_spd</td></tr>\n";
        echo "<tr><td>Total download size</td><td>$str_total_download_size </td></tr>\n";
        echo "<tr><td>Average download speed</td><td>$str_avg_download_spd</td></tr>\n";
        echo "<tr><td>Number of login attempts</td><td>$str_num_logins</td></tr>\n";
        echo "<tr><td>Total IP addresses</td><td>$str_num_ip_origins</td></tr>\n";
        echo "<tr><td>Most active IP addresse</td><td>$str_most_active_ip</td></tr>\n";
        echo '</tbody></table>'; 
        echo "</div>";  
        //
       
		
        asort($date_range); // old date first
		if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
			$start_date = $_REQUEST['dateselbox_s'];
		if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
			$end_date = $_REQUEST['dateselbox_e'];
		foreach($date_range as $key => $val)
		{
			if(($val >= $start_date && $val <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			{
				$param_out = "";
				$param_in = "";
				
               echo "<div class='info'>";
                echo "<table>\n";
                echo '<COL id="col1"><COL id="col2">';
                echo '<TR id="row1">';
                echo "    <TD> <h4>[$val]" . "</h4>\n";
                //echo "    <TD> <h2>Average speed on $val" . "</h2>\n";
                //echo "<h2>Net traffic on $val" . "</h2>\n";

				for($i=0;$i<24;$i++)
				{
					$khour = sprintf("%02d",$i);
					if(isset($datehour_traffic_o[$val][$khour]))
					{
					//	echo $khour . ": " . $datehour_traffic_o[$val][$khour] . ",";
						$param_out = $param_out . $khour . ":" . $datehour_traffic_o[$val][$khour] . ",";
					}
				}
				//echo "<p>UL:</p>\n";
				for($i=0;$i<24;$i++)
				{
					$khour = sprintf("%02d",$i);
					if(isset($datehour_traffic_i[$val][$khour]))
					{
						//echo $khour . ": " . $datehour_traffic_i[$val][$khour] . ",";
						$param_in = $param_in . $khour . ":" . $datehour_traffic_i[$val][$khour] . ",";
					}
				}
                echo '<TR id="row2">';
				echo "    <TD> <center><img width=492 height=200 src='" . "operate.php?op=trafficchart&param1=" . $param_out . "&param2=" . $param_in  . "&param3=" . $key . "'></center></TD>";
                //echo "<center><img width=480 height=220 src='" . "operate.php?op=trafficchart&param1=" . $param_out . "&param2=" . $param_in  . "&param3=" . $key . "'></center>";
				//echo "<h2>The average speed of U/L and D/L on $val" . "</h2>\n";
				$param_out = "";
				$param_in = "";
				for($i=0;$i<24;$i++)
				{
					$khour = sprintf("%02d",$i);
					if(isset($datehour_spd_o[$val][$khour]))
					{
					//echo $khour . ": " . $datehour_spd_o[$val][$khour] . ",";
						$param_out = $param_out . $khour . ":" . $datehour_spd_o[$val][$khour] . ",";
					}
				}
				//echo "<p>UL:</p>\n";
				for($i=0;$i<24;$i++)
				{
					$khour = sprintf("%02d",$i);
					if(isset($datehour_spd_i[$val][$khour]))
					{
						//echo $khour . ": " . $datehour_spd_i[$val][$khour] . ",";
						$param_in = $param_in . $khour . ":" . $datehour_spd_i[$val][$khour] . ",";
					}
				}
				echo "    <TD> <center><img width=492 height=200 src='" . "operate.php?op=spdchart&param1=" . $param_out . "&param2=" . $param_in  . "&param3=" . $key . "'></center></TD>";
			    echo "</tr>\n";
                echo "</Table>\n";
                echo "</div>";
            }
		}
		echo "</div>";
        echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
	}

	function genTopstatistics($filename)
	{
		global $topsize;
        global $subfolderignore;
        $fpath = generateLogPath($filename);
		$total_input_size = 0; // total input traffic in bytes
		$total_output_size = 0; // total input traffic in bytes
		$date_range = array();
        $user_logins = array();
        $group_logins = array();
		$user_to_group_map = array();
		$user_upload_bytes = array();
		$user_download_bytes = array();
		$group_upload_bytes = array();
		$group_download_bytes = array();
		$user_upload_hits = array();
		$user_download_hits = array();
		$group_upload_hits = array();
		$group_download_hits = array();
		$stime = microtime(true);
		$lines = file($fpath);
		$linecount = 0;
		
        //Top Array
        //key:User/group [0]:value [1]:arrayfolders [2]:files
        
        foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			$vald = substr($tokens[3],0,10);
			if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
				$start_date = $_REQUEST['dateselbox_s'];
			if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
				$end_date = $_REQUEST['dateselbox_e'];
			if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			{
				$current_username = $tokens[1]; // username
				$garray = explode(",",$tokens[2]);
				if(count($garray) > 1)
					$current_group = $garray[0];  // group
				else
					$current_group = $tokens[2];  // group
				$user_to_group_map[$current_username] = $current_group;
				
                if($tokens[4] == "w") // make top uploaders
				{
					if(count($tokens) == 8)
					{
						if(is_numeric($tokens[6])) // input size in bytes
						{
							$total_input_size = $total_input_size + $tokens[6];
							$spath = basepath($tokens[5],$subfolderignore);
                            if(isset($user_upload_bytes[$current_username]) == false)
                            {
								$user_upload_bytes[$current_username][0] = $tokens[6];
                                $user_upload_bytes[$current_username][1] = array(0 => $spath);
                                $user_upload_bytes[$current_username][2] = 1;
                            }    
							else
							{   $user_upload_bytes[$current_username][0] = $user_upload_bytes[$current_username][0] + $tokens[6];
                                if (in_array($spath,$user_upload_bytes[$current_username][1]) == false)
                                { array_push($user_upload_bytes[$current_username][1], $spath); }
                                $user_upload_bytes[$current_username][2] = $user_upload_bytes[$current_username][2] + 1;
                            }    
                                 
							if(isset($group_upload_bytes[$current_group]) == false)
							{	$group_upload_bytes[$current_group][0] = $tokens[6];
                                $group_upload_bytes[$current_group][1] = array(0 => $spath);
                                $group_upload_bytes[$current_group][2] = 1;
							}
                            else
							{	$group_upload_bytes[$current_group][0] = $group_upload_bytes[$current_group][0] + $tokens[6];
                                if (in_array($spath,$group_upload_bytes[$current_group][1]) == false)
                                { array_push($group_upload_bytes[$current_group][1], $spath); }
                                $group_upload_bytes[$current_group][2] = $group_upload_bytes[$current_group][2] + 1;
						
                            }
                        }
					}
				}
				else if($tokens[4] == "r") // input traffic
				{
					if(count($tokens) == 8)
					{
						if(is_numeric($tokens[6])) // output size in bytes
						{
							$total_output_size = $total_output_size + $tokens[6];
                            $spath = basepath($tokens[5],$subfolderignore);
                            if(isset($user_download_bytes[$current_username]) == false)
                            {
                                $user_download_bytes[$current_username][0] = $tokens[6];
                                $user_download_bytes[$current_username][1] = array(0 => $spath);
                                $user_download_bytes[$current_username][2] = 1;
                            }    
                            else
                            {   $user_download_bytes[$current_username][0] = $user_download_bytes[$current_username][0] + $tokens[6];
                                if (in_array($spath,$user_download_bytes[$current_username][1]) == false)
                                { array_push($user_download_bytes[$current_username][1], $spath); }
                                $user_download_bytes[$current_username][2] = $user_download_bytes[$current_username][2] + 1;
                            }    
                                 
                            if(isset($group_download_bytes[$current_group]) == false)
                            {    $group_download_bytes[$current_group][0] = $tokens[6];
                                 $group_download_bytes[$current_group][1] = array(0 => $spath);
                                 $group_download_bytes[$current_group][2] = 1;
                            }
                            else
                            {   $group_download_bytes[$current_group][0] = $group_download_bytes[$current_group][0] + $tokens[6];
                                if (in_array($spath,$group_download_bytes[$current_group][1]) == false)
                                { array_push($group_download_bytes[$current_group][1], $spath); }
                                $group_download_bytes[$current_group][2] = $group_download_bytes[$current_group][2] + 1;
                            }
						}
					}
				}
                else if ($tokens[4] == "l")
                {
                    if(isset($user_logins[$current_username]) == false)
                        { $user_logins[$current_username] = 1; }    
                    else
                        { $user_logins[$current_username] = $user_logins[$current_username] + 1; } 
                    
                    if(isset($group_logins[$current_group]) == false)
                        { $group_logins[$current_group] = 1; }    
                    else
                        { $group_logins[$current_group] = $group_logins[$current_group] + 1; }     
                    
                }
			}
		}
		$etime = microtime(true);
		$str_lines               = $linecount;
		$str_time_taken          = round(($etime - $stime),3) . " s";
		$str_size_logfile        = byte_format(filesize($fpath));
		$str_total_upload_size   = byte_format($total_input_size);
		$str_total_download_size = byte_format($total_output_size);
		
         echo '<div class="info">';
        // New info
        echo '<table id="gridInfo" class="gridInfo" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=400>Information</td><td width=100>Value</td></tr></thead><tbody>';
        echo "<tr><td>Total number of lines in LOG file</td><td>$linecount</td></tr>\n";
        echo "<tr><td>Time taken for analysis</td><td>$str_time_taken</td></tr>\n";
        echo "<tr><td>LOG file size</td><td>$str_size_logfile</td></tr>\n";
        echo "<tr><td>Total input size</td><td>$str_total_upload_size</td></tr>\n";
        echo "<tr><td>Total output size</td><td>$str_total_download_size</td></tr>\n";
        echo '</tbody></table>';   
        // 
        echo '</div>';
        
 		arsort($user_upload_bytes);
		$counter = 0;
		echo "<h3>Top$topsize - Uploaders by Size</h3>";
		echo '<div class="gridcontainer">';
        echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50><div class="mycenter">No.</div></td><td width=120>Username</td><td width=120>Group</td><td>Transfer size</td><td>Percentage</td></tr></thead><tbody>';
		foreach($user_upload_bytes as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
			{ $itag = "<div class='rank'>$counter</div>"; }
              
            $folders = count($val[1]);
            $files   = $val[2];
            if(isset($user_logins[$key]) == true)
                { $logins = $user_logins[$key]; }
            else { $logins = 0; }
               
		    echo "<tr><td>$itag</td><td title='Logins: $logins'>$key</td><td>" . $user_to_group_map[$key] . "</td><td title='Folders: $folders\nFiles: $files'>" . byte_format($val[0]) . "</td><td>" . round($val[0]/$total_input_size,4)*100 . "%</td></tr>";
		}
		echo '</tbody></table>';
        echo '</div>';
		arsort($user_download_bytes);
		$counter = 0;
		echo "<h3>Top$topsize - Downloaders by Size</h3>";
		echo '<div class="gridcontainer">';
        echo '<table id="grid2" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50><div class="mycenter">No.</div></td><td width=120>Username</td><td width=120>Group</td><td>Transfer size</td><td>Percentage</td></tr></thead><tbody>';
		foreach($user_download_bytes as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
			{ $itag = "<div class='rank'>$counter</div>"; }
            
            $folders = count($val[1]);
            $files   = $val[2];
            
            $ret = in_array($key,$user_logins);
            if(isset($user_logins[$key]) == true)
                { $logins = $user_logins[$key]; }
            else { $logins = 0; }
            
		    echo "<tr><td>$itag</td><td title='Logins: $logins'>$key</td><td>" . $user_to_group_map[$key] . "</td><td title='Folders: $folders\nFiles: $files'>" . byte_format($val[0]) . "</td><td>" . round($val[0]/$total_output_size,4)*100 . "%</td></tr>";
		}
		echo '</tbody></table>';
        echo '</div>';
		arsort($group_upload_bytes);
		$counter = 0;
		echo "<h3>Top$topsize - Uploader Groups by Size</h3>";
		echo '<div class="gridcontainer">';
        echo '<table id="grid3" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50><div class="mycenter">No.</div></td><td width=120>Group</td><td>Transfer size</td><td>Percentage</td></tr></thead><tbody>';
		foreach($group_upload_bytes as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				{ $itag = "<div class='rank'>$counter</div>";}
                
                $folders = count($val[1]);
                $files   = $val[2];
                
                if(isset($group_logins[$key]) == true)
                { $logins = $group_logins[$key]; }
                else { $logins = 0; }
            
		        echo "<tr><td>$itag</td><td title='Logins: $logins'>$key</td><td title='Folders: $folders\nFiles: $files'>" . byte_format($val[0]) . "</td><td>" . round($val[0]/$total_input_size,4)*100 . "%</td></tr>";
		}
		echo '</tbody></table>';
        echo '</div>';
		arsort($group_download_bytes);
		$counter = 0;
		echo "<h3>Top$topsize - Downloader Groups by Size</h3>";
		echo '<div class="gridcontainer">';
        echo '<table id="grid4" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50><div class="mycenter">No.</div></td><td width=120>Group</td><td>Transfer size</td><td>Percentage</td></tr></thead><tbody>';
		foreach($group_download_bytes as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				{ $itag = "<div class='rank'>$counter</div>"; }
            
            $folders = count($val[1]);
            $files   = $val[2];
            
            if(isset($group_logins[$key]) == true)
                { $logins = $group_logins[$key]; }
            else { $logins = 0; }
		    echo "<tr><td>$itag</td><td title='Logins: $logins'>$key</td><td title='Folders: $folders\nFiles: $files'>" . byte_format($val[0]) . "</td><td>" . round($val[0]/$total_output_size,4)*100 . "%</td></tr>";
		}
		echo '</tbody></table>';
        echo '</div>';
        echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
	}

	function queryDateRange($filename)
	{
		$fpath = generateLogPath($filename);
		$date_range = array();
        $users      = array();
		$groups     = array();
        $lines = file($fpath);
		$linecount = 0;
		foreach($lines as $line_num => $line)
		{
			$linecount ++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			
            if(count($tokens) >= 6)
            {
                $date1 = substr($tokens[3],0,10);
			    if(isset($date_range[$date1]) == false) // there is Activity on this day
			    $date_range[$date1] = $date1;
                
                //check users
                $user = substr($tokens[1],0);
                if (in_array($user,$users,true) == false)
                {
                    array_push($users,$user);
                }
                
                //check groups
                $tmpgroups = substr($tokens[2],0);
                $gtokens = csv_explode(",",$tmpgroups);
                foreach($gtokens as $group)
                {
                   if (in_array($group,$groups,true) == false)
                   {
                    array_push($groups,$group);
                    } 
                }

            }
		}
		$curloglines = $linecount;
		$curlogsize  = filesize($fpath);
		$curlogname  = $filename;
		
		asort($date_range); // old date first
		// generating date selection box
		$acount = count($date_range);
		$loopcount = 0;
		$start_date = "";
		$end_date = "";
		// $startcount = $acount - 7;
		// if($startcount < 0)
		$startcount = 0;
		$selbox_out_s = "<SELECT name='dateselbox_s' onChange='top.topFrame.frm1.dateselbox_s.value=this.value;'>\n";
		foreach($date_range as $key => $val) // from selection box
		{
			if($loopcount == $startcount || $start_date == $val)
			{
				$start_date = $val;
				$selbox_out_s = $selbox_out_s . " <OPTION value='$val' SELECTED>$key</OPTION>\n";
			}
			else
				$selbox_out_s = $selbox_out_s . " <OPTION value='$val'>$key</OPTION>\n";
			$loopcount++;
		}
		$selbox_out_s = $selbox_out_s . "</SELECT>\n";
		arsort($date_range); // last date first
		$selbox_out_e = "<SELECT name='dateselbox_e' onChange='top.topFrame.frm1.dateselbox_e.value=this.value;'>\n";
		foreach($date_range as $key => $val) // to selection box
		{
			if($end_date == "")
				$end_date = $val;
			if($end_date == $val)
				$selbox_out_e = $selbox_out_e . " <OPTION value='$val' SELECTED>$key</OPTION>\n";
			else
				$selbox_out_e = $selbox_out_e . " <OPTION value='$val'>$key</OPTION>\n";
		}
		$selbox_out_e = $selbox_out_e . "</SELECT>\n";
		echo "Date Range: from " . $selbox_out_s . " to " . $selbox_out_e;
		
		//Write to session vars
		$_SESSION['currentlog']  = $curlogname . "|" . $linecount . "|" . $curlogsize  . "|" . $start_date   . "|" . $end_date; 
		$_SESSION['currentusers']  = $users;
        $_SESSION['currentgroups']  = $groups;
        session_commit();
        
	}

	function genHitoMeter($filename,$mode) // mode 4 dirs 5 files
	{
		global $topsize;
        global $subfolderignore;
        global $fileignore;
        $fpath = generateLogPath($filename);
		$total_input_size = 0; // total input traffic in bytes
		$total_output_size = 0; // total input traffic in bytes
		$date_range = array();
		$popularpaths_dl = array();
		$popularpaths_dlsize = array();
		$popularpaths_ul = array();
		$popularpaths_ulsize = array();
		$stime = microtime(true);
		$lines = file($fpath);
		$linecount = 0;
		foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			$vald = substr($tokens[3],0,10);
			if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
				$start_date = $_REQUEST['dateselbox_s'];
			if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
				$end_date = $_REQUEST['dateselbox_e'];
			if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			{
				$current_username = $tokens[1]; // username
				$garray = explode(",",$tokens[2]);
				if(count($garray) > 1)
					$current_group = $garray[0];  // group
				else
					$current_group = $tokens[2];  // group
				if($tokens[4] == "w") // make top uploaders
				{
					if(count($tokens) == 8)
					{
						if(is_numeric($tokens[6])) // input size in bytes
						{
							if($mode == 4)
								$basepath = basepath($tokens[5],$subfolderignore); // path
							else if($mode == 5)
								$basepath = basename($tokens[5]); // file
							if($basepath == "\\")
								$basepath = "/";
                                
                            $regmask = "#(?i:" . $fileignore . ")#";
                            if ((preg_match($regmask, $basepath) == 0) || ($fileignore == ""))
                            {
							    if(isset($popularpaths_ul[$basepath]) == false)
								{   $popularpaths_ul[$basepath][0] = 1;
                                    $popularpaths_ul[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]);
                                    $popularpaths_ul[$basepath][2] = $tokens[6];
							    }
                                else
								{   $popularpaths_ul[$basepath][0]++;
							        if (array_key_exists($tokens[1],$popularpaths_ul[$basepath][1]) == true)
                                    { $popularpaths_ul[$basepath][1][$tokens[1]][1] = $tokens[3]; }
                                    else
                                    { $popularpaths_ul[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]); }
                                      $popularpaths_ul[$basepath][2] = $popularpaths_ul[$basepath][2] + $tokens[6];
                                }
                                
                                if(isset($popularpaths_ulsize[$basepath]) == false)
								{   $popularpaths_ulsize[$basepath][0] = $tokens[6];
                                    $popularpaths_ulsize[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]);
                                    $popularpaths_ulsize[$basepath][2] = 1;
							    }
                                else
								{   $popularpaths_ulsize[$basepath][0] = $popularpaths_ulsize[$basepath][0] + $tokens[6];
                                    if (array_key_exists($tokens[1],$popularpaths_ulsize[$basepath][1]) == true)
                                    { $popularpaths_ulsize[$basepath][1][$tokens[1]][1] = $tokens[3]; }
                                    else
                                    { $popularpaths_ulsize[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]); }
                                      $popularpaths_ulsize[$basepath][2] = $popularpaths_ulsize[$basepath][2] + 1;
						        }
                            }
                        }    
					}
				}
				else if($tokens[4] == "r") // input traffic
				{
					if(count($tokens) == 8)
					{
						if(is_numeric($tokens[6])) // output size in bytes
						{
							if($mode == 4)
								$basepath = basepath($tokens[5],$subfolderignore); // path
							else if($mode == 5)
								$basepath = basename($tokens[5]); // file
							if($basepath == "\\")
								$basepath = "/";
							
                            $regmask = "#(?i:" . $fileignore . ")#"; 
                            if ((preg_match($regmask, $basepath) == 0) || ($fileignore == ""))
                            {
                                if(isset($popularpaths_dl[$basepath]) == false)
                                {   $popularpaths_dl[$basepath][0] = 1;
                                    $popularpaths_dl[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]);
                                    $popularpaths_dl[$basepath][2] = $tokens[6];
                                }
                                else
                                {   $popularpaths_dl[$basepath][0]++;
                                    if (array_key_exists($tokens[1],$popularpaths_dl[$basepath][1]) == true)
                                    { $popularpaths_dl[$basepath][1][$tokens[1]][1] = $tokens[3]; }
                                    else
                                    { $popularpaths_dl[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]); }
                                    $popularpaths_dl[$basepath][2] = $popularpaths_dl[$basepath][2] + $tokens[6];
                                }
                                
                                if(isset($popularpaths_dlsize[$basepath]) == false)
                                {   $popularpaths_dlsize[$basepath][0] = $tokens[6];
                                    $popularpaths_dlsize[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]);
                                    $popularpaths_dlsize[$basepath][2] = 1;
                                }
                                else
                                {   $popularpaths_dlsize[$basepath][0] = $popularpaths_dlsize[$basepath][0] + $tokens[6];
                                    if (array_key_exists($tokens[1],$popularpaths_dlsize[$basepath][1]) == true)
                                    { $popularpaths_dlsize[$basepath][1][$tokens[1]][1] = $tokens[3]; }
                                    else
                                    { $popularpaths_dlsize[$basepath][1][$tokens[1]] = array(0 => $tokens[3], 1 => $tokens[3]); }
                                     $popularpaths_dlsize[$basepath][2] = $popularpaths_dlsize[$basepath][2] + 1;
                                }
						
                            }
                        }
					}
				}
			}
		}
		$etime = microtime(true);
		$str_lines               = $linecount;
        $str_time_taken          = round(($etime - $stime),3) . " s";
        $str_size_logfile        = byte_format(filesize($fpath));
        
        echo '<div class="info">';
        // New info
        echo '<table id="gridInfo" class="gridInfo" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="400">Information</td><td width="100">Value</td></tr></thead><tbody>';
        echo "<tr><td>Total number of lines in LOG file</td><td>$linecount</td></tr>\n";
        echo "<tr><td>Time taken for analysis</td><td>$str_time_taken</td></tr>\n";
        echo "<tr><td>LOG file size</td><td>$str_size_logfile</td></tr>\n";
        echo "<tr><td>Top Results</td><td>Top$topsize</td></tr>\n";
        echo '</tbody></table>';   
        // 
        echo '</div>';
		
   
        //arsort($popularpaths_dl);
        $arrcount = array_map('col_0', $popularpaths_dl);
        $arrsize = array_map('col_2', $popularpaths_dl);
        array_multisort($arrcount, SORT_DESC, $arrsize, SORT_DESC, $popularpaths_dl);

		$counter = 0;
		if($mode == 4)
			$itemname = "Folders";
		else if($mode == 5)
			$itemname = "Files";
		echo "<h3>Top$topsize - $itemname by Download Requests</h3>";
		echo '<div class="gridcontainer">';
        echo '<table id="grid1" class="grid" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="50"><div class="mycenter">No.</div></td><td>Filename</td><td>Count</td><td>Size</td></tr></thead><tbody>';
		foreach($popularpaths_dl as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
                
            $userstr = "";
            if (isset($popularpaths_dl[$key][1]) == true)
               { 
                   foreach ($popularpaths_dl[$key][1] as $userkey => $userval)
                   { 
                       if($mode == 4) { $userstr = $userstr . $userkey . "\n  Start: " . $userval[0] . "\n  End: " . $userval[1] . "\n"; }
                       else if($mode == 5) { $userstr = $userstr . $userkey . "\n  End: " . $userval[0] . "\n"; }
                   } 
               }   
                
		  echo "<tr><td>$itag</td><td title='$userstr'><div class='path'>$key</div></td><td>$val[0]</td><td white-space: nowrap>" . byte_format($val[2],2) . "</td></tr>";
			if($counter >= intval($topsize))
				break;
		}
		echo '</tbody></table>';
        echo '</div>';
        
		//arsort($popularpaths_dlsize);
        $arrcount = array_map('col_0', $popularpaths_dlsize);
        $arrsize = array_map('col_2', $popularpaths_dlsize);
        array_multisort($arrcount, SORT_DESC, $arrsize, SORT_DESC, $popularpaths_dlsize);
        
		$counter = 0;
		echo "<h3>Top$topsize - $itemname by Download Size</h3>";
		echo '<div class="gridcontainer">';
        echo '<table id="grid2" class="grid" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="50"><div class="mycenter">No.</div></td><td>Filename</td><td>Size</td><td>Count</td></tr></thead><tbody>';
		foreach($popularpaths_dlsize as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
			
           $userstr = "";
           if (isset($popularpaths_dlsize[$key][1]) == true)
           { 
               foreach ($popularpaths_dlsize[$key][1] as $userkey => $userval)
               { 
                    if($mode == 4) { $userstr = $userstr . $userkey . "\n  Start: " . $userval[0] . "\n  End: " . $userval[1] . "\n"; }
                    else if($mode == 5) { $userstr = $userstr . $userkey . "\n  End: " . $userval[0] . "\n"; }
               } 
           } 
            
            echo "<tr><td>$itag</td><td title='$userstr'><div class='path'>$key</div></td><td white-space: nowrap>" . byte_format($val[0],2) . "</td><td>$val[2]</td></tr>";
			if($counter >= intval($topsize))
				break;
		}
		echo '</tbody></table>';
        echo '</div>';
        
               
		//arsort($popularpaths_ul);
        $arrcount = array_map('col_0', $popularpaths_ul);
        $arrsize = array_map('col_2', $popularpaths_ul);
        array_multisort($arrcount, SORT_DESC, $arrsize, SORT_DESC, $popularpaths_ul);
        
		$counter = 0;
		echo "<h3>Top$topsize - $itemname by Upload Attempts</h3>";
		echo '<div class="gridcontainer">';
        echo '<table id="grid3" class="grid" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="50"><div class="mycenter">No.</div></td><td>Filename</td><td>Count</td><td>Size</td></tr></thead><tbody>';
		foreach($popularpaths_ul as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
           
           $userstr = "";
           if (isset($popularpaths_ul[$key][1]) == true)
           { 
               foreach ($popularpaths_ul[$key][1] as $userkey => $userval)
               { 
                    if($mode == 4) { $userstr = $userstr . $userkey . "\n  Start: " . $userval[0] . "\n  End: " . $userval[1] . "\n"; }
                    else if($mode == 5) { $userstr = $userstr . $userkey . "\n  End: " . $userval[0] . "\n"; }
               } 
           }
  
			echo "<tr><td>$itag</td><td title='$userstr'><div class='path'>$key</Div></td><td>$val[0]</td><td white-space: nowrap>" . byte_format($val[2],2) . "</td></tr>";

			if($counter >= intval($topsize))
				break;
		}
		echo '</tbody></table>';
        echo '</div>';
        
		//arsort($popularpaths_ulsize);
		$arrcount = array_map('col_0', $popularpaths_ulsize);
        $arrsize = array_map('col_2', $popularpaths_ulsize);
        array_multisort($arrcount, SORT_DESC, $arrsize, SORT_DESC, $popularpaths_ulsize);
        
        $counter = 0;
		echo "<h3>Top$topsize - $itemname by Upload Size</h3>";
		echo '<div class="gridcontainer">';
        echo '<table id="grid4" class="grid" border="0" cellspacing="0" cellpadding="0"><thead><tr><td width="50"><div class="mycenter">No.</div></td><td>Filename</td><td>Size</td><td>Count</td></tr></thead><tbody>';
		foreach($popularpaths_ulsize as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
			
           $userstr = "";
           if (isset($popularpaths_ulsize[$key][1]) == true)
           { 
               foreach ($popularpaths_ulsize[$key][1] as $userkey => $userval)
               { 
                    if($mode == 4) { $userstr = $userstr . $userkey . "\n  Start: " . $userval[0] . "\n  End: " . $userval[1] . "\n"; }
                    else if($mode == 5) { $userstr = $userstr . $userkey . "\n  End: " . $userval[0] . "\n"; }
               } 
           }
           
           echo "<tr><td>$itag</td><td title='$userstr'><div class='path'>$key</Div></td><td>" . byte_format($val[0],2) . "</td><td>$val[2]</td></tr>";
		   
           if($counter >= intval($topsize))
				break;
		}
		echo '</tbody></table>';
        echo '</div>';
        echo '<div class="page_foot">Page generated in ' . round((microtime(true) - $stime),3) . 's.<div/>';
	}

	function createChart($op,$arro,$arri,$dates)
	{
		header("Content-type: image/png");
		$maxYval = 0;
		$xAxisTitle = "hour of day";
		$sysroot = getenv("SystemRoot");
		$font = $sysroot . "\\fonts\\" . 'segoeui.ttf';
		if(file_exists($font) == false)
			$font = $sysroot . "\\fonts\\" . 'arial.ttf';
		if($op == "spdchart")
		{
			$yAxisTitle1 = "Speed";
			$yAxisTitle2 = "";
			$topTitle = "Speed chart";
		}
		else if($op == "trafficchart" || isset($op) == false)
		{
			$yAxisTitle1 = "Traffic";
			$yAxisTitle2 = "";
			$topTitle = "Traffic chart";
		}
        $legendUp = "Upload";
        $legendDn = "Download";
        
		$line_y_base = 240;
		$line_x_base = 60;
		$im = @imagecreatetruecolor(640,260) or die("Cannot Initialize new GD image stream");
		imageantialias($im,true);
		$background_color = imagecolorallocate($im,220,229,236);
		imagefill($im,0,0,$background_color);
		$text_color = imagecolorallocate($im,10,14,91);
		$title_color = imagecolorallocate($im,0,0,0);
		$dash_color = imagecolorallocate($im,140,200,200);
		$border_t = imagecolorallocate($im,200,200,200);;
		$border_d = imagecolorallocate($im,160,102,120);;
		$border_l = imagecolorallocate($im,190,200,200);;
		$border_r = imagecolorallocate($im,140,160,120);;
		$style = array($dash_color,$dash_color,$background_color,$background_color,$dash_color,$dash_color,$background_color,$background_color);
		$baseline_color = imagecolorallocate($im,0,0,5);
		$line_color1 = imagecolorallocate($im,0,241,0);
		$line_color2 = imagecolorallocate($im,255,5,0);
		//imagestring($im,1,10,5,$topTitle,$text_color);
		imagettftext($im,12,0,300,20,$text_color,$font,$topTitle);
		imageline($im,60,20,60,240,$baseline_color);
		imageline($im,0,0,639,0,$border_t);
		imageline($im,0,259,639,259,$border_d);
		imageline($im,0,0,0,259,$border_l);
		imageline($im,639,0,639,259,$border_r);
		imagettftext($im,9,0,560,253,$title_color,$font,$xAxisTitle);
		imagettftext($im,8,0,10,15,$title_color,$font,$yAxisTitle1);
		imagettftext($im,8,0,10,45,$title_color,$font,$yAxisTitle2);
		//	imagestring($im,1,565,462,$xAxisTitle,$title_color);
		//	imagestring($im,1,10,20,$yAxisTitle1,$title_color);
		//	imagestring($im,1,10,40,$yAxisTitle2,$title_color);
        
        // Legend
        imagettftext($im,8,0,580,15,$line_color2,$font,$legendUp);
        imagettftext($im,8,0,580,25,$line_color1,$font,$legendDn);
        
        
        
		$arr0 = explode(",",$arro);
		foreach($arr0 as $key => $val)
		{
			$arr1 = explode(":",$val);
			if(count($arr1) == 2)
			{
				if($arr1[0] >= 0 && $arr1[0] <= 23)
				{
					$arr_out[$arr1[0]] = $arr1[1];
					if($arr1[1] > $maxYval)
						$maxYval = $arr1[1];
				}
			}
		}
		$arr0 = explode(",",$arri);
		foreach($arr0 as $key => $val)
		{
			$arr1 = explode(":",$val);
			if(count($arr1) == 2)
			{
				if($arr1[0] >= 0 && $arr1[0] <= 23)
				{
					$arr_in[$arr1[0]] = $arr1[1];
					if($arr1[1] > $maxYval)
						$maxYval = $arr1[1];
				}
			}
		}
		for($i=1;$i<24;$i++)
		{
			imagettftext($im,8,0,58+$i*20,253,$text_color,$font,$i);
            imageline($im,58+$i*20,240,58+$i*20,235,$text_color);
			//		imagestring($im,1,60+$i*20,462,$i,$text_color);
		}
		for($i=0;$i<=10;$i++)
		{
			$ySlice = $maxYval/10;
            $yVal =   $ySlice*$i;
			$txt = sprintf("%d",$ySlice*$i);
			if($op == "spdchart")
				$txt = $txt . "k";
			else if($op == "trafficchart")
				$txt = byte_format($yVal);
            if($i > 0)
			{
				imagettftext($im,8,0,10,244-(20*$i),$text_color,$font,$txt);
				imageline($im,61,240-(20*$i),620,240-(20*$i),$dash_color);
			}
		}
		$lastx = $line_x_base;
		$lasty = $line_y_base;
		for($i=0;$i<24;$i++) // draw line
		{
			$i = sprintf("%02d",$i);
			if(isset($arr_out[$i]) == false || $arr_out[$i] == 0)
				$arr_out[$i] = 0;
			else
				$arr_out[$i] = 200 * ($arr_out[$i]/$maxYval);
			imageline($im,$lastx,$lasty,$line_x_base+$i*20,$line_y_base-$arr_out[$i],$line_color1);
			$lastx = $line_x_base+$i*20;
			$lasty = $line_y_base-$arr_out[$i];
		}
		imageline($im,$lastx,$lasty,$lastx,$line_y_base,$line_color1); // drop to zero
		$lastx = $line_x_base;
		$lasty = $line_y_base;
		for($i=0;$i<24;$i++) // draw line
		{
			$i = sprintf("%02d",$i);
			if(isset($arr_in[$i]) == false || $arr_in[$i] == 0)
				$arr_in[$i] = 0;
			else
				$arr_in[$i] = 200 * ($arr_in[$i]/$maxYval);
			imageline($im,$lastx,$lasty,$line_x_base+$i*20,$line_y_base-$arr_in[$i],$line_color2);
			$lastx = $line_x_base+$i*20;
			$lasty = $line_y_base-$arr_in[$i];
		}
		imageline($im,$lastx,$lasty,$lastx,$line_y_base,$line_color2); // drop to zero
		imageline($im,60,240,620,240,$baseline_color); // overwrite bottom line again
		
        //Output        
        imagepng($im);
        imagedestroy($im);
	}

	if(isset($_SESSION['logon_user']) == false)
		die("Not logged in");
	if(isset($_REQUEST['op']) == true)
		$op = $_REQUEST['op'];
	else
		$op = "";
	if(isset($_REQUEST['param1']) == true)
		$p1 = rawurldecode($_REQUEST['param1']);
	else
		$p1 = "";
	if(isset($_REQUEST['param2']) == true)
		$p2 = rawurldecode($_REQUEST['param2']);
	else
		$p2 = "";
	if(isset($_REQUEST['param3']) == true)
		$p3 = rawurldecode($_REQUEST['param3']);
	else
		$p3 = "";

	if($op == "trafficgraph")
	{
		genTrafficGraph($p1);
	}
	else if($op == "topstatistics")
	{
		genTopstatistics($p1);
	}
	else if($op == "daterange")
	{
		queryDateRange($p1);
	}
	else if($op == "hitometer")
	{
		genHitoMeter($p1,$p2);
	}
	else if($op == "showoperation")
	{
		genLogList($p1,$p2);
	}
	else if($op == "usage")
	{
		genUsage($p1,$p2);
	}
    else if($op == "rawlog")
    {
        include ("filter.php");
    }
    else if(($op == "rawlogquery") || ($op == "showfoldersdl") || ($op == "showfoldersul"))
    {
        if ($op == "showfoldersdl") { $actions = "download"; }
        if ($op == "showfoldersul") { $actions = "upload"; }
        genFilteredLogList($p1);
    }
	else if($op == "spdchart" || $op == "trafficchart")
	{
		createChart($op,$p1,$p2,$p3);
	}
?>